﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.01
@EndOfDesignText@
'version 1.00
Sub Class_Globals
	Type ExpandableItemData (CollapsedHeight As Int, ExpandedHeight As Int, Value As Object, Expanded As Boolean)
	Private mCLV As CustomListView
	Private xui As XUI
	Private DragTop, DragY As Int 
End Sub

Public Sub Initialize (CLV As CustomListView)
	mCLV=CLV
End Sub

public Sub Add(pnl As B4XView,value As Object )
	mCLV.Add(pnl, CreateValue(pnl, "some value"))
End Sub

Public Sub CreateValue(pnl As B4XView, Value As Object) As ExpandableItemData
	Dim e As ExpandableItemData
	e.Initialize
	e.CollapsedHeight = pnl.GetView(0).Height
	e.ExpandedHeight = pnl.GetView(0).Height + pnl.GetView(1).Height
	e.Value = Value
	Return e
End Sub

Public Sub GetValue (Index As Int) As Object
	If mCLV.GetValue(Index) Is ExpandableItemData Then
		Dim e As ExpandableItemData = mCLV.GetValue(Index)
		Return e.Value
	End If
	Return mCLV.GetValue(Index)

End Sub

Private Sub ResizeItem (Index As Int, Collapse As Boolean)
	Dim item As CLVItem = mCLV.GetRawListItem(Index)
	Dim p As B4XView = item.Panel.GetView(0)
	If p.NumberOfViews = 0 Or (item.Value Is ExpandableItemData) = False Then Return
	Dim NewPanel As B4XView = xui.CreatePanel("")
	MoveItemBetweenPanels(p, NewPanel)
	Dim id As ExpandableItemData = item.Value
	id.Expanded = Not(Collapse)
	mCLV.sv.ScrollViewInnerPanel.AddView(NewPanel, 0, item.Offset, p.Width, id.ExpandedHeight)
	Dim NewSize As Int
	If Collapse Then NewSize = id.CollapsedHeight Else NewSize = id.ExpandedHeight
	mCLV.ResizeItem(Index, NewSize)
	NewPanel.SendToBack
	Sleep(mCLV.AnimationDuration)
	If p.Parent.IsInitialized Then
		MoveItemBetweenPanels(NewPanel, p)
	End If
	NewPanel.RemoveViewFromParent
End Sub


Private Sub MoveItemBetweenPanels (Src As B4XView, Target As B4XView)
	Do While Src.NumberOfViews > 0
		Dim v As B4XView = Src.GetView(0)
		v.RemoveViewFromParent
		Target.AddView(v, v.Left, v.Top, v.Width, v.Height)
	Loop
End Sub


Sub OpenItem(lbl As B4XView)
	Dim index As Int=mCLV.GetItemFromView(lbl)
	Dim data As ExpandableItemData = mCLV.GetValue(index)
	ResizeItem(index,data.Expanded)
End Sub


Sub PickItem(MouseY As Int,lbl As B4XView)
	Dim pnl As B4XView = mCLV.GetPanel(mCLV.GetItemFromView(lbl)).Parent
	pnl.GetView(0).SetColorAndBorder(xui.Color_Transparent, 3dip, 0xFF503ACD, 0)
	DragY  = MouseY+ lbl.Top + pnl.Top
	pnl.BringToFront
	DragTop = pnl.Top
End Sub


Sub MoveItem(MouseY As Int,lbl As B4XView)
	Dim pnl As B4XView 	= mCLV.GetPanel(mCLV.GetItemFromView(lbl)).Parent
	CheckScrollViewOffset(pnl)
	Dim clvY As Int = MouseY + lbl.Top + pnl.Top
	Dim delta As Int = clvY - DragY
	pnl.Top = DragTop + delta
End Sub


Sub DropItem(lbl As B4XView)
	Dim index As Int = mCLV.GetItemFromView(lbl)
	Dim pnl As B4XView = mCLV.GetPanel(index).Parent
	Dim Offset As Int = pnl.Top '+ pnl.Height / 2
	Dim NewIndex As Int = mCLV.FindIndexFromOffset(Offset)
	Dim UnderlyingItem As CLVItem = mCLV.GetRawListItem(NewIndex)
	If Offset - UnderlyingItem.Offset > UnderlyingItem.Size / 2 Then NewIndex = NewIndex + 1
	Dim ActualItem As B4XView = pnl.GetView(0)
'	ActualItem.SetColorAndBorder(pnl.Color, 0dip, xui.Color_Black, 0)
	Dim RawItem As CLVItem = mCLV.GetRawListItem(index)
	mCLV.RemoveAt(index)
	If NewIndex > index Then NewIndex = NewIndex - 1
	NewIndex = Max(0, Min(mCLV.Size, NewIndex))
	mCLV.InsertAt(NewIndex, ActualItem, RawItem.Value)
	mCLV.GetRawListItem(NewIndex).TextItem = RawItem.TextItem
End Sub



Private Sub CheckScrollViewOffset(pnl As B4XView)
	If pnl.Top < mCLV.sv.ScrollViewOffsetY Then
		mCLV.sv.ScrollViewOffsetY = Max(0, mCLV.sv.ScrollViewOffsetY - 10dip)
	Else If mCLV.sv.ScrollViewOffsetY + mCLV.sv.Height < pnl.Top + pnl.Height Then
		mCLV.sv.ScrollViewOffsetY = mCLV.sv.ScrollViewOffsetY + 10dip
	End If
End Sub